package com.jiuqi.util.comparator;

import java.util.Comparator;

public final class ObjectComparator implements Comparator {
   private boolean isDescOrder;

   public ObjectComparator() {
   }

   public ObjectComparator(boolean isDescOrder) {
      this.isDescOrder = isDescOrder;
   }

   public int compare(Object o1, Object o2) {
      if (o1 == o2) {
         return 0;
      } else {
         int ret = 0;
         if (o1 == null) {
            ret = -1;
         } else if (o2 == null) {
            ret = 1;
         } else if (o1 instanceof Comparable) {
            ret = ((Comparable)o1).compareTo(o2);
         } else if (o2 instanceof Comparable) {
            ret = -((Comparable)o2).compareTo(o1);
         } else if (o1 instanceof Boolean && o2 instanceof Boolean) {
            ret = ((Boolean)o1 ? 1 : 0) - ((Boolean)o2 ? 1 : 0);
         }

         return this.isDescOrder ? -ret : ret;
      }
   }

   public boolean equals(Object obj) {
      if (this == obj) {
         return true;
      } else if (this != null && obj != null) {
         if (obj instanceof ObjectComparator) {
            return ((ObjectComparator)obj).isDescOrder == this.isDescOrder;
         } else {
            return false;
         }
      } else {
         return false;
      }
   }

   public String toString() {
      return "[对象比较器, " + (this.isDescOrder ? "降序]" : "升序]");
   }

   public boolean isDescOrder() {
      return this.isDescOrder;
   }

   public void setDescOrder(boolean isDescOrder) {
      this.isDescOrder = isDescOrder;
   }
}
